#!/usr/bin/perl

#Tells program to die if command line does not include any arguments.

$filedata = $ARGV[0] or die "Error: add filename at command line\n\n"; #Argument 1 is the fasta delimited file to count GC content for each entry.

open (SEQ, "<$filedata") or die "Error: $filedata file not found!\n\n";
open (OUT, ">results.txt"); #Specifies output name.

#Initialize necessary variables.

$sequence;
$a = 0;
$c = 0;
$t = 0;
$g = 0;
$sum = 0;

print STDERR "Reading input...";

#Read in fasta delimited file as two arrays, one with the names of each entry and one with the sequences

while (<SEQ>) {
	chomp;
	if (/>/) {
	    $seq_name=$';#'
		push(@seq_names, $seq_name);
	    if ($newseq==1) {push(@sequences, $sequence);}
	    $sequence = "";
	    $newseq=0;
	    next;
	} else {
	    $sequence .= $_;
	    $newseq=1;
	} #end else
} #end while
push(@sequences, $sequence);

print STDERR "done\n";

#count bases

print STDERR "Performing GC calculations..";

for ($i=0; $i <= $#sequences; $i++) {

$a = ($sequences[$i] =~ tr/Aa//);
$c = ($sequences[$i] =~ tr/Cc//);
$g = ($sequences[$i] =~ tr/Gg//);
$t = ($sequences[$i] =~ tr/Tt//);
$n = ($sequences[$i] =~ tr/Nn//);

$sumGC = $c + $g;
$sumTOTAL = $a + $c +$t +$g;

push(@GCcount, $sumGC);
push(@TOTALcount, $sumTOTAL);
push(@Ncount, $n);

} #end for

print STDERR "done.\n";

print STDERR "Writing output...";

#Print header

print OUT "sequence name\ttotal GC bases\ttotal N bases\ttotal non-N bases\n";

#Print loop

for ($k=0; $k <= $#seq_names; $k++) {

    print OUT "$seq_names[$k]\t$GCcount[$k]\t$Ncount[$k]\t$TOTALcount[$k]\n";

} #end for

print STDERR "done.\n";

close;
exit; 

