#! /usr/bin/perl

#getting crossover / recombination estimates

#Define command line inputs: 
#1) Recombination data with marker names as the header (first cell, A1, blank) and each row being an individual with name in column A and genotype for each marker in the corresponding columns (excel file saved as *.csv), (sample file: 'crossovers by individual.txt'
#2) output file name

$recdata = $ARGV[0];
$output = $ARGV[1];

open (RECDATA, $recdata);
open (OUTPUT, ">$output");

$whileloopcounter=0;

while (<RECDATA>) {

    if ($whileloopcounter==0) {
	$marker_names=$_;
	@marker_name_list=split(",", $marker_names); #generates an array of all the marker names
	$whileloopcounter=1;
    } #end if

    else {
	@row=split ",";
	push(@column, [ @row ]); #generates a 2-D array of all the individuals
    } #end else

} #end while

$loopcounter=0;
@countarray=();

#For loop to count number of crossovers for each interval
#Reads in each pair of markers first

for ($i=1; $i<=$#row; $i++) {
    $n=$i+1;

    if ($loopcounter==1) {
	push(@countarray, $count);
    } #end if

    $count=0;	

#For loop to count number of crossovers between $i and $n markers.

    for ($j=0; $j<=$#column; $j++) {

	$loopcounter=1;

	if ($column[$j][$i]!=$column[$j][$n]) {
	    $count++;
	} #end if
	
	else {
	    next;
	} #end else
    
    } #end for

} #end for

push(@countarray, $count); #count array to capture the counts for each interval

#Print statement of header for output

print OUTPUT "\#crossovers\tinterval start\tinterval end\n";
#print $countarray[0];

#Print loop for each interval defining first marker and last marker and the counts.

for ($k=1; $k<$#marker_name_list; $k++) {
    $l=$k+1;
    $m=$k-1;
    print OUTPUT "$countarray[$m]\t$marker_name_list[$k]\t$marker_name_list[$l]\n";
} #end for

