#! /usr/bin/perl
 
#1/2/2010 LSS 

#Subroutine to kill program if enough inputs aren't specified on the command line. 
sub usage { 
  print STDERR "usage: extract sequences <Source sequence file> <list of positions>\n\n"; 
  print STDERR "Extracts positions from source sequence file and outputs a fasta delimited file.\n"; 
  print STDERR "Creator: Laurie Stevison\n"; 
  exit; 
} #end sub 
 
  if ($#ARGV  != 1) { # zero means one argument 
     &usage; 
  } 

#Define command line arguments
$source = $ARGV[0]; #argument 1 is the genome source for extracting the map intervals
$positions = $ARGV[1];  #argument 2 is the list of positions to extract
$output = $source . ".txt";  #specifies output file name

  open(READSRC, $source); 
  open(READPOS, $positions); 
  open(WRITEOUT, ">$output"); 

    print STDERR "Reading input file...";

#Reads list of positions into arrays

while (<READPOS>) {
    chomp;
    $input = $_; 
    @input_array = split(/\s+/, $input);

    push(@group_start_name , $input_array[0]);
    push(@position_start , $input_array[1]);
    push(@group_end_name , $input_array[2]);
    push(@position_end , $input_array[3]);

} #end while

    print STDERR "done.\n\n";

    print STDERR "Reading source file...";

#Reads in source file with names of fasta entries and their sequences for extracting

while (<READSRC>) {
    chomp;
    if (/>/) { 
	$seq_name = $'; #'
	push(@grp_names, $seq_name);
	if ($newseq==1) {push(@sequences, $sequence);} 
	$sequence = "";
	$newseq=0;
	next; 
    } else {
	$sequence .= $_;
	$newseq=1; 
    } #end else
} #end while
    push(@sequences, $sequence);

    print "done.\n\n";

#Now use the positions to extract the sequences from the source file.

print STDERR "Extracting positions...\n";

for ($i = 0; $i <= $#position_start; $i++) {

    if ($group_start_name[$i] eq $group_end_name[$i]) {

    $grp_name = $group_start_name[$i]; #compare fasta entry in source with specified header in input list.

    for ($k = 0; $k <= $#grp_names; $k++) {
	@short_name = split(" ", $grp_names[$k]);
	if ($short_name[0] eq $grp_name) {
	    $hold_sequence = $sequences[$k];
	} else {
	    next;
	} #end else
    } #end for

#Performs substring operation to extract the sequence

    $start_substr = $position_start[$i] - 1;
    $length_substr = $position_end[$i] - $position_start[$i];
    $extract = substr($hold_sequence,  $start_substr, $length_substr);

#Prints fasta delimited file with information on the extracted positions

    print WRITEOUT ">Interval $grp_name:$position_start[$i]..$grp_name:$position_end[$i]\n";
    print WRITEOUT "$extract\n";

    } else {

#Only enters here if the map interval specified spans more than one fasta entry.
#This exxtracts the sequences from both specified fasta entries in the source file and concatenates them for the output.

    $grp1_name = $group_start_name[$i];
    $grp2_name = $group_end_name[$i];

    for ($k = 0; $k <= $#grp_names; $k++) {
	@short_name = split(" ", $grp_names[$k]);
	if ($short_name[0] eq $grp1_name) {
	    $hold_sequence1 = $sequences[$k];
	} elsif ($short_name[0] eq $grp2_name) {
	    $hold_sequence2 = $sequences[$k];
	} else {
	    next;
	} #end else
    } #end for

    $start_substr1 = $position_start[$i] - 1;
    $length_substr1 = length ($hold_sequence1);
    $length_substr2 = $position_end[$i] - 1;
    $extract1 = substr($hold_sequence1,  $start_substr1, $length_substr1);
    $extract2 = substr ($hold_sequence2, 0, $length_substr2);

    print WRITEOUT ">Interval $grp1_name:$position_start[$i]..$grp2_name:$position_end[$i]\n";
    print WRITEOUT "$extract1" . "$extract2\n";

    } #end else

} #end for
    print STDERR "done.\n\n";
