#!/usr/bin/perl

#Define command line arguments and set up error statements if not defined.

$filedata = $ARGV[0] or die "Error: add filename at command line\n\n"; #Argument 1 is fasta delimited file of sequences to search
$motifs = $ARGV[1] or die "Error: add file with motifs to search at command line\n\n"; #Argument 2 is fasta delimited file of motifs to search

open (SEQ, "<$filedata") or die "Error: $filedata file not found!\n\n";
open (MOTIF, "<$motifs") or die "Error: motif file not found!\n\n";

print STDERR "Reading sequence file input...";

#Read in the sequences file

while (<SEQ>) {
	chomp;
	if (/>/) {
	    $seq_name=$';#'
		push(@seq_names, $seq_name);
	    if ($newseq==1) {push(@sequences, $sequence);}
	    $sequence = "";
	    $newseq=0;
	    next;
	} else {
	    $sequence .= $_;
	    $newseq=1;
	} #end else
} #end while

push(@sequences, $sequence);

print STDERR "done\n\n";

print STDERR "Searching motifs requested...\n";

#Define arrays and dummy seperator

@motif_names = ();
$dummy_seperator = "crapinahat";

#Read in motifs sequences

while (<MOTIF>) {
    chomp; 
 
   if (/>/) {

	$motif_name=$';#'
	    open (OUT2, ">motif_test_results.txt");
	push(@motif_names, $motif_name);
	next;
    } else {
	$motif_seq=$_;
	if ($motif_seq=~/N/) {
	    $motif_seq=~tr/N/./;
	} #end if
	@motif_length = split("", $motif_seq);

    $while_counter +=1; 
    print STDERR "\t\tNow searching motif $while_counter...\t\t";

    } #end else

#Print header

    print OUT "Sequence\tNumber $motif_name found\tTotal motifs checked for $motif_name\n";

#This i-loop pulls substrings serially from the source file the same length as each motif and compares it against the motif

    for ($i=0; $i <= $#sequences; $i++) {

	@interval_seq = split("", $sequences[$i]);
	$loop_length = ($#interval_seq) - ($#motif_length);

	    @check_motif = ();
	    $check_motif = "";

#This j-loop serially generates substrings to search

	for ($j=0; $j <=$loop_length; $j++) {

#Removes a single sequence the same length as the motif searching

	        for ($k=0; $k <= $#motif_length; $k++) {
		    $m=($k+$j);
		    push(@check_motif, $interval_seq[$m]);
	        } #end for

#Joins the however-many basepairs

	    $check_motif= join("", @check_motif);

#Compares check motif to actual motif and keeps count of how many checks it has done (of check motifs NOT containing N's).

	        if ($check_motif !~ /N/i) {
		        $total += 1;
	             if ($check_motif=~/$motif_seq/i) {
		        $count += 1;
		    } #end if
		} #end if

	    @check_motif = ();
	    $check_motif = "";

	} #end for

	push(@count_array, $count);
	push(@totals_array, $total);

    $count = 0;
    $total = 0;

    } #end for

	push(@count_array, $dummy_seperator);
	push(@totals_array, $dummy_seperator);

    $motif_name="";
    close OUT;
    print STDERR "motif $while_counter complete.\n";

} #end while

print STDERR "Search completed.\n";

print STDERR "Writing final output...\t\t";

#Print header and print header loop

print OUT2 "Sequence";

for ($p=0; $p<=$#motif_names; $p++) {

    print OUT2 "\t$motif_names[$p] count\t$motif_names[$p] total";

} #end for

$n_loop_counter=0;

#Print loop

for ($l=0; $l <=$#sequences; $l++) {

#Prints name of each sequence

    print OUT2 "\n$seq_names[$l]";

    $string_of_countarray = join(":", @count_array);
    $string_of_totalsarray = join(":", @totals_array);

    @all_count_arrays=split($dummy_seperator, $string_of_countarray);
    @all_totals_arrays=split($dummy_seperator, $string_of_totalsarray);

#Prints results for each motif

    for ($n=0; $n <=$#motif_names; $n++) {

	if ($n_loop_counter==0) {

	@final_count_array = split(":", $all_count_arrays[$n]);
	@final_totals_array = split(":", $all_totals_arrays[$n]);
	print OUT2 "\t$final_count_array[$l]\t$final_totals_array[$l]";
	$n_loop_counter = 1;

	} else {

	@final_count_array = split(":", $all_count_arrays[$n]);
	@final_totals_array = split(":", $all_totals_arrays[$n]);
	print OUT2 "\t$final_count_array[$l+1]\t$final_totals_array[$l+1]";

	} #end else

    } #end for

$n_loop_counter=0;

} #end for

print STDERR "All outputs written.\n";
