#!/usr/bin/perl

#take output from compilesnps.pl and Input name list
#create hash of input names and list 5 snps per target location
#choose top five based on # of reads, proximity to target location, quality score

#17/6/2008 LSS
 
sub usage { 
    print STDERR "usage: compile SNPs <Input names>\n\n"; 
    print STDERR "reads output of compilesnps.pl, gives only top 5 SNPs per target and gives blast info\n"; 
    print STDERR "Author: Laurie Stevison\n"; 
    exit; 
} #end sub

if ($#ARGV  != 0) { # zero means one argument 
    &usage; 
} #end if

$input_names = $ARGV[0];
$compile = "Final_SNPS.txt"; 
open (READINPUT, $input_names);
open(COMPILED_LIST, "Compiled_SNPS.txt");
open(WRITECOMPILE, ">$compile"); 
system "blastall -p blastn -d scaffolds -i tempfile -o outputfile -e 1e-5 -m0";
system "./parse_per_blastout.pl outputfile";
open (BLASTOUT, "positions_output");

$first_inner_loop=1;

@blast_outs=();

	while (<BLASTOUT>) {
	    chomp;
	    if ($first_inner_loop==0) {
		$blast_out = $_;
		#print STDERR "$blast_out\n";
		push(@blast_outs, $blast_out);
	    } else {
		$first_inner_loop = 0;
		print STDERR "Reading in BLAST output...\n";
		next;
	    } #end else
        } #end while

print STDERR "Done reading in BLAST output.\n";

print WRITECOMPILE "Target Position\tSNP Position\tMSH3 Seq\tMSH 1993 Seq\tQuality Score\tSNP Sequence\tNumber of Reads\tScore\tE-value\tscorenext hit\tE-value next hit\tBLAST scaffold\tBLAST position\tSNP type\t454 Read names";

@inputs=();
@highsnps=();
@hold_highsnps=();
$first_loop=1;    

    while (<COMPILED_LIST>) {
	chomp;
	#print STDERR "Made it into while loop! woohoo!\n";
	#$hold_out = "";
	if ($first_loop==0) {
	    $hold_out = $_;
	    #print STDERR "$hold_out\n";
	    @hold_outs = split("\t", $hold_out);    
	    for ($i=0; $i<=$#blast_outs; $i++) {
		$blast_out_i = $blast_outs[$i];
		@blast_out_new=split("\t", $blast_out_i);
	    #print STDERR "hold_out 1: $hold_outs[1]; blast_out 0: $blast_outs[0]\n";
		if ($hold_outs[1] eq $blast_out_new[0]) {
		    #print STDERR "Statement true\n";
		    push(@hold_outs, $blast_out_new[2], $blast_out_new[3], $blast_out_new[4], $blast_out_new[5], $blast_out_new[1], $blast_out_new[7]);
		} #end if
	    } #end for

	    $new_hold_out=join("\t", @hold_outs);
	    push(@hold_highsnps, $new_hold_out);
	} else {
	    $first_loop=0;
	    next;
	} #end else
    } #end while

print STDERR "Read in compilesnps output.\n";

$hold_input = "";
@hold_inputs=();

while (<READINPUT>) {
    chomp;
    $hold_input=$_;
    push(@hold_inputs, $hold_input);
} #end while

@inputs = sort @hold_inputs;
@highsnps = sort @hold_highsnps;

print STDERR "Read in input list\n";

for ($i=0; $i<=$#inputs; $i++) {
    #print STDERR "Made it into first for loop\n";
    $targetpos=$inputs[$i];
    $next_targetpos=$inputs[$i+1];
    $current_pos_has_snp=0;
    for ($k=0;$k<=$#highsnps;$k++) {
	#print STDERR "Made it into second for loop\n";
	@target_snps=split("\t", $highsnps[$k]);

	if ($targetpos eq $target_snps[0]) {
	    #print STDERR "First if statement passed\n";
	    $number_of_reads=$target_snps[6];
	    #print STDERR "number of reads: $number_of_reads\n";
	    print WRITECOMPILE "\n$targetpos\t$target_snps[1]\t$target_snps[2]\t$target_snps[3]\t$target_snps[4]\t$target_snps[5]\t$target_snps[6]\t";
	    $current_pos_has_snp=1;
	    for ($j=$number_of_reads+8; $j<=$#target_snps; $j++) {
		print WRITECOMPILE "$target_snps[$j]\t";
	    } #end for

	    for ($h=7; $h<=$number_of_reads+7;$h++) {
		print WRITECOMPILE "$target_snps[$h]\t";
	    } #end for

	} elsif ($next_targetpos eq $target_snps[0]) {

	    #print STDERR "Second if statement passed\n";
	    if ($current_pos_has_snp!=1) {
		    print WRITECOMPILE "\n$targetpos\tNo SNPs for defined target sequence";
	    #} elsif ($current_pos_has_snp==1) {
		#$number_of_reads=$target_snps[6];
		#print WRITECOMPILE "\n$next_targetpos\t$target_snps[1]\t$target_snps[2]\t$target_snps[3]\t$target_snps[4]\t$target_snps[5]\t$target_snps[6]\t";

		#for ($l=$number_of_reads+8; $l<=$#target_snps; $l++) {
		    #print WRITECOMPILE "$target_snps[$l]\t";
		#} #end for
		#for ($m=7; $m<=$number_of_reads+7;$m++) {
		    #print WRITECOMPILE "$target_snps[$m]\t";
		#} #end for
	    } #end if
	last;
	} #end elsif
    } #end for
} #end for

	    print WRITECOMPILE "\n";
print STDERR "Made it to the end!\n";
