#!/usr/bin/perl
 
#28/5/2008 LSS
 
sub usage { 
  print STDERR "usage: compile SNPs <Input names> <quality cutoff>\n\n"; 
  print STDERR "reads output of getgoodsnps.pl, compiles 'good' SNP locations, sequences, quality scores, etc.\n"; 
  print STDERR "Author: Laurie Stevison\n"; 
  exit; 
} #end sub

  if ($#ARGV  != 1) { # zero means one argument 
     &usage; 
  } #end if

  $input_names = $ARGV[0];
  $qual_cutoff= $ARGV[1];
  $compile = "Compiled_SNPS.txt"; 
  open (READINPUT, $input_names);
  open(WRITECOMPILE, ">$compile"); 
  open (TEMP, ">tempfile");  # make temporary file from which to BLAST this one sequence
print WRITECOMPILE "Target Position\tSNP Position\tMSH3 Seq\tMSH 1993 Seq\tQuality Score\tSNP Sequence\tNumber of Reads\tSNP type\t454 Read names";

    @inputs=();
    @highsnps=();
    $hold_input = "";
    $hold_out = "";
    $hold_snp = "";
    
    while (<READINPUT>) {
	chomp;
	$hold_input=$_;
	push(@inputs, $hold_input);
    } #end while

for ($i=0; $i<=$#inputs; $i++) {

    $targetpos=$inputs[$i];

    open(EACHINPUT, $inputs[$i]. ".highSNPs");
    $first_loop=1;
    while (<EACHINPUT>) {
    chomp;
    if ($first_loop==0) {
    $hold_out = $_;
    @hold_out = split("\t", $hold_out);
    #print "@hold_out\n";
    } else {
	$first_loop=0;
	next;
    } #end else

    if ($hold_out[7] ne "bad snp" && $hold_out[5]>$qual_cutoff && $hold_out[3]!~/N/ && $hold_out[4]!~/N/ && $hold_out[3]!~/-/ && $hold_out[4]!~/-/) {
	push(@hold_out, $targetpos);
	$new_hold_out=join("\t", @hold_out);
	push(@highsnps, $new_hold_out);
	push(@positions, $hold_out[0]) ;
	} #end if
  } #end while
} #end for

    foreach $positions (@positions) {
	$reads{$positions} += 1;
    } #end foreach


    @newpositions = sort @positions;
    @newhighsnps = sort @highsnps;

foreach (@newhighsnps) {
    @hold_snps = split("\t", $_);
    @hold_snps_old = split("\t", $hold_snp_old);
    #print "First argument: $hold_snps[0], second argument: $hold_snps_old[0]\n";
    if ($hold_snps[0] ne $hold_snps_old[0]) {
	#print "Statement true!\n";
    foreach (@newpositions) {
	$k = $_;
	#print "Got into the third for loop!\n";
	if ($hold_snps[0] ne $k) {
	    print WRITECOMPILE "\n$hold_snps[8]\t$hold_snps[0]\t$hold_snps[3]\t$hold_snps[4]\t$hold_snps[5]\t$hold_snps[6]\t$reads{$hold_snps[0]}\t$hold_snps[7]\t$hold_snps[1]\t";
	    $header=$hold_snps[0];
	    $sequence=$hold_snps[6];
	    $sequence =~ s/^\[|^\]//;
	    #$sequence =~ s/^\[|^\]//;
	    #$sequence =~ s/\/\w\]//;
	    print TEMP ">$header\n$sequence\n";
	    last;
	} else {
	    next;
	} #end else

    } #end for

    } elsif ($hold_snps[0] eq $hold_snps_old[0]) {
	    print WRITECOMPILE "$hold_snps[1]\t";
	} #end elsif
    $hold_snp_old=$_;
} #end for

print WRITECOMPILE "\n";


