#!/usr/bin/perl
 
#23/5/2008
 
sub usage { 
  print STDERR "usage: getgoodsnps <Fasta output file name> <454 qual file name>\n\n"; 
  print STDERR "reads a Fasta output, identifies SNP locations and gives quality scores of those SNPs\n"; 
  print STDERR "Creator: Laurie Stevison\n"; 
  exit; 
} #end sub 
 
  if ($#ARGV  != 1) { # zero means one argument 
     &usage; 
  } 
  $fasta = $ARGV[0]; 
  $quals = $ARGV[1]; 
  $highname = $fasta . ".highSNPs"; 
  open(READFAS, $fasta); 
  open(READQUAL, $quals); 
  open(WRITEHIGH, ">$highname"); 

@qualnames = ();
@qualscores = ();
$first_qual_loop = 1;
$holdqname = "";
$holdqual="";

while (<READQUAL>) { 
  chomp; 
  if (/>/) {
      $holdqname = $'; #'
	  push(@qualnames, $holdqname);
      if ($first_qual_loop==0) {
	  push (@qualscores, $holdqual);
      } #end if
      $first_qual_loop=0;
      $holdqual = "";
  next;
  } else { 
  $holdqual .= $_; 
  } # end else         
} # end while          

  push (@qualscores, $holdqual);

print WRITEHIGH "SNP Position\t454 read name\tMarker ID\tMSH3 Seq\tMSH 1993 Seq\tQuality Score\tSNP Sequence\tGood SNP?\n";

$first_fasta_loop=1;

chomp ($first_line=<READFAS>);

@first_line = split(/\s+/, $first_line);
$full_target_position=@first_line[11];
@the_further_split = split(/\./, $full_target_position);
$actual_target_position = $the_further_split[1];
$target_scaffold=$the_further_split[0];
#print STDERR "$first_line\n$full_target_position\n$actual_target_position\n$target_scaffold\n";

while (<READFAS>) { 
      chomp;
    if (/^>>/) {   #alignment
	   if ($first_fasta_loop==1) {
	       $first_fasta_loop=0;
	       $firstentry=1;
	} #end if
	   elsif ($firstentry==1) {
	       $alignname=$';#'
	       $firstentry=0;
	} #end elsif
	   else {
	       $alignname=$next;
        } #end else
	$query=1;
     } #end if
	
      elsif (/fa_opt:/) { 
	    $score=$'; #'
	} #end elsif
	
      elsif (/bs_ident: /) { 
	  $percentmatch=$'; #'
	} #end elsif
	
      elsif (/bs_overlap: /) {
	    $overlap=$';#'
	} #end elsif

      elsif (/>/) { 
	    $query=1;
	    $matchq=$'; #' will always  be query name
        }#end elsif 
      
      elsif (/al_start: /) { 
    
            if ($query==1) { 
		$qposB=$'; #first time through will be query position begin'
                } #end if	       
            else {
                $sposB=$'; #second time through will be subject position begin '
	    } #end else
        }#end elsif 
	
       elsif (/al_stop: /) {
       
            if ($query==1) { 
		$qposE=$'; #'first time through will be query position end
	    } #end if		
            else { 
                $sposE=$'; #'second time through will be subject position end
                } #end else
        } #end elsif

        elsif (/al_display_start:/) {
                $holdseq = "";
		$next="";

		while (<READFAS>) {
		     chomp;
                  if(/>/) {
                      $next=$'; #'
                      last;
                   } else {
                      $holdseq .= $_;
                   } # end else
                } # end while                       

                 if ($query==1) {
                    $startpos=$'; #'
	           
		   if ($qposB < $startpos) {
		       $offset = ($startpos-$qposB);
		       $orientation = -1;
		   } else {
		       $offset= ($qposB-$startposB);
		       $orientation = 1;
		   } #end else
		   
		    $seqQ=$holdseq; #
                    $query=0; # set query as false, next time through will be subject		    
		    $seqQshort = substr($seqQ, $offset);  
		    @seqarrayQ = split("", $seqQshort); 
                    $matchs=$next; #second time through will be subject name
		 } #end if

		 else {
		    $seqS=$holdseq; # second time through, sequence will be subject
		    $seqSshort = substr($seqS, $offset);  
		    @seqarrayS = split("", $seqSshort);         
                    @newseqarray = ();
		    @snpqualarray = ();
		    @snp_S = ();
		    @snp_Q = ();
         	    @newqualarray=();
		    @snppos = ();
		    
		    for ($i=0; $i<$#qualnames; $i++) {
			
			if ($qualnames[$i] eq $alignname) {
			    $newholdqual = $qualscores[$i];
			    last;
			} else {
			    next;
			} # end else
		    } #end for

		    for  ($i=0; $i < $#seqarrayS; $i++) {
                          @newqualarray = split (/\s+/, $newholdqual);
          		  if ($seqarrayQ[$i] eq $seqarrayS[$i]) {
			      push (@newseqarray, $seqarrayS[$i]);
		          } else {
                              push (@newseqarray, "[$seqarrayQ[$i]/$seqarrayS[$i]]");
			      push (@snp_S, $seqarrayS[$i]);
			      push (@snp_Q, $seqarrayQ[$i]);
			      push (@snppos, $i);        
			      push (@snpqualarray, $newqualarray[$i]);
                          } #end else
	            } #end for
		 		 
		    @snp_seq = ();		
		    $seq = join ("",@newseqarray);
		    @goodsnps = ();
		    
		    for ($i=0; $i <= $#snppos; $i++) {
		      
			    if ($i==$#snppos) {
				$j=$#seqarrayS;
			    } else {
			        $j=$snppos[$i+1];
			    } # end else

	
			if ($i==0) {
			    $k=0, $start=0, $length=($j+(4*($i+1))-$k); 
			} #end if 
      			else {
			    $k=$snppos[$i-1], $start=($k+(4*$i)+1), $length=($j+(4*($i+1))-$k-5); 
			} #end else

			  if ((($snppos[$i] - $k) >  50) && (($j - $snppos[$i]) > 50)) {
			      push (@goodsnps, "50 on both sides");
			      $snp_seq = substr($seq,$start,$length);
			      push(@snp_seq, $snp_seq);

			      } elsif ((($snppos[$i] - $k) >  50) || (($j - $snppos[$i]) > 50)) {
			   
			           if ((($snppos[$i] - $k) > 40) && (($j - $snppos[$i]) > 40)) {
				       push (@goodsnps, "at least 40 on both sides");
				       $snp_seq = substr($seq,$start,$length);
				       push(@snp_seq, $snp_seq);

				   } elsif  ((($snppos[$i] - $k) >  25) && (($j - $snppos[$i]) > 25)) {
				       push (@goodsnps, "at least 25 on both sides");
				       $snp_seq = substr($seq,$start,$length);
				       push(@snp_seq, $snp_seq);

				   } else {
				       push (@goodsnps, "50 on one side only");
				       $snp_seq = substr($seq,$start,$length);
				       push(@snp_seq, $snp_seq);
				   } #end else

			   } else {
			      push (@goodsnps, "bad snp");
			      $snp_seq = substr($seq,$start,$length);
			      push(@snp_seq, $snp_seq);
			   } # end else
			
			if (orientation==1) {
			    $absq_pos = $actual_target_position + (($qposB +$snppos[$i])-10000);
			} else {
			    $absq_pos = $actual_target_position + (10000-($qposB-$snppos[$i]));
			} #end else			

			print WRITEHIGH "$target_scaffold" . "." .  "$absq_pos\t$alignname\t$matchq\t$snp_Q[$i]\t $snp_S[$i]\t$snpqualarray[$i]\t$snp_seq[$i]\t$goodsnps[$i]\n";
		    } #end for
		    $_ = $next;
		    s/>//;
                 $alignname=$_;
		 } #end else
	}#end elsif
      #elsif (/>>><<</) {
	  #last;
      #} #end elsif
} # end while 
