#! /usr/bin/perl

#quick program to parse blast output for positions
#works with command line -p blastn -m0 input commands

$blast_out = @ARGV[0];

$output = "positions_output";

open (READBLAST, $blast_out);
open (WRITEOUT, ">$output");
print WRITEOUT "D.ps. position\tD.per. scaffold\tScore\tE-value\tnext hit score\tnext hit E-value\tOrientation\tD.per. position\n";

$newentry=0;

while (<READBLAST>) {
    chomp;
      if (/Query= /) {
	  if ($newentry==0) {
	      $dps_pos = $'; #'
		  print WRITEOUT "$dps_pos\t";
	      $newentry=1;
	      $align = 1;
	  } #end if
	  elsif ($newentry==1) {
	      print WRITEOUT "No hits found.\n";
	      $dps_pos = $'; #'
		  print WRITEOUT "$dps_pos\t";
	      $align=1;
	  } #end elsif
      } #end if

      elsif (/super_/) {

	    $dper_scaffold = $'; #'
	    @dper_scaffold = split(/\s+/, $dper_scaffold);	
	    #print WRITEOUT "\n$'\n";

      	    if ($newentry==1 && $align==1) {
		#print WRITEOUT "\n$dper_scaffold\n";
        	print WRITEOUT "super_" . "@dper_scaffold[0]\t@dper_scaffold[1]\t@dper_scaffold[2]\t";
		$firstalign = 1;
		$align=2;
		$newentry=0;
 	    } #end if

	    elsif ($newentry==0 && $align==2) {
	    $align=0;	      
		#print WRITEOUT "\n$dper_scaffold\n";
	    if (defined(@dper_scaffold[2])) {
		    print WRITEOUT "@dper_scaffold[1]\t@dper_scaffold[2]\t";
	    } else {
		    print WRITEOUT "only one hit!\t\t"; 		
	    } #end else
 	} #end elsif 
      } #end elsif

       elsif (/Strand = /)  {
      	    if ($firstalign==1) {
		$orientation = $'; #'
		    print WRITEOUT "$orientation\t";
	    } #end if

	    else {
	    next;
	    }#end else
	    
        } #end elsif 

	elsif (/Sbjct: /){
	
		if ($firstalign==1) {
		$position = $'; #'
		    @positions = split(" ", $position);
		    print WRITEOUT "@positions[0]\n";
		} #end if
	
		else {
		next;
		} #end else

		$firstalign=0;
		
        } #end elsif

} #end while

