#! /usr/bin/perl

#quick program to parse blast output for positions
#works with command line -p blastn -m0 input commands

$blast_out = @ARGV[0];

$output = "positions_output";

open (READBLAST, $blast_out);
open (WRITEOUT, ">$output");
print WRITEOUT "D.per. position\tD.ps. group\tScore\tE-value\tnext hit score\tnext hit E-value\tOrientation\tD.ps. position\n";

$newentry=0;

while (<READBLAST>) {
    chomp;
      if (/Query= /) {
	  if ($newentry==0) {
	      $dper_pos = $'; #'
		  print WRITEOUT "$dper_pos\t";
	      $newentry=1;
	      $align = 1;
	  } #end if
	  elsif ($newentry==1) {
	      print WRITEOUT "No hits found.\n";
	      $dper_pos = $'; #'
		  print WRITEOUT "$dper_pos\t";
	      $align=1;
	  } #end elsif
      } #end if

      elsif (/\.{3}/) {

	    $dps_group = $`; #'
	    $dps_score = $'; #' 
	    @dps_score = split(/\s+/, $dps_score);	
	    #print WRITEOUT "\n$'\n";

      	    if ($newentry==1 && $align==1) {
		$align=2;
		$newentry=0;
		next;
	    } #end if
	    
	    elsif ($newentry==0 && $align==2) {
		#print WRITEOUT "\n$dper_scaffold\n";
        	print WRITEOUT "$dps_group\t@dps_score[1]\t@dps_score[2]\t";
	    $firstalign = 1;
	    $align=3;
 	    } #end if

	    elsif ($newentry==0 && $align==3) {
	    $align=0;	      
		#print WRITEOUT "\n$dper_scaffold\n";
		    print WRITEOUT "@dps_score[1]\t@dps_score[2]\t";
	    } #end elsif
	    #else {
 		#next;
	    #} #end else
 	} #end elsif 

       elsif (/Strand = /)  {
      	    if ($firstalign==1) {
		if ($align==3) {
		    print WRITEOUT "only one hit!\t\t";
		} #end if
		$orientation = $'; #'
		    print WRITEOUT "$orientation\t";
	    } #end if

	    else {
	    next;
	    }#end else
	    
        } #end elsif 

	elsif (/Sbjct: /){
	
		if ($firstalign==1) {
		$position = $'; #'
		    @positions = split(" ", $position);
		    print WRITEOUT "@positions[0]\n";
		} #end if
	
		else {
		next;
		} #end else

		$firstalign=0;
		
        } #end elsif

} #end while

